<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leonardocarvalho
 * Date: 16/09/13
 * Time: 13:19
 * To change this template use File | Settings | File Templates.
 */

namespace BancoTalentos\Logic\Mail;

use BancoTalentos\Logic\BTL;

class SolicitaCadastro {

    private $xls;
    private $xlsPath;

    const SUBJECT_RECUPERAR_SENHA = 'Cadastre seu currículo';
    const COLUNA_NM_CANDIDATO = 1;
    const COLUNA_EMAIL_CANDIDATO = 3;

    /**
     * Carrega template do body do email
     * @return $template
     * @author leonardocarvalho
     */
    private function getTemplate(){

        $nrorg = 1001;//BTL::getNrorg();
        $nmoperador = 'Leandro Afonso';//BTL::getNmoperador();
        $logo_bottom = 'http://vagas.pebbian.com/images/pebbian_logotipo.png';
        $logo_organização = 'http://rh.pebbian.com/images/logo/'.$nrorg.'-logo.png';
        $imgAcessoSistema = 'http://vagas.pebbian.com/images/acesse_sistema.jpg';
        $linkSistema = 'http://vagas.pebbian.com/alibras';

        $template = <<<HTML
                    <!--<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> -->
                    <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
                    <html>
                    <head>
                        <title>Recuperação de Senha</title>
                    </head>
                    <body style="text-align: center; padding-top: 2%; padding-left: 22%; background-color: rgb(118, 192, 179); margin: 0px; height: auto;">
                        <div style="width:672px; height:427px; box-shadow: 10px 10px 5px #78887d;">
                            <table cellpadding="0" cellspacing="0" style="width: 674px; height: 375px; margin: 0 auto;">
                                <tr style="background-color: #FFF">
                                    <td height="20">
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr style="background-color: #FFF;">
                                    <td style="text-align: center;">
                                        <img src="$logo_organização" />
                                    </td>
                                </tr>
                                <tr style="background-color: #FFF">
                                    <td height="35">
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr style="background-color: #FFF; text-align: left; font: normal 14px Arial, Tahoma, sans-serif; color: #333;">
                                    <td>
                                        <table cellpadding="0" cellspacing="0">
                                            <tr>
                                                <td width="24"></td>
                                                <td height="193">
                                                    <h1 style="font-size: 30px; margin: 0 0 15px 0; color: #76c0b3;">Olá $nmoperador</h1>
                                                    <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                        Nosso sistema de cadastros de currículos mudou.
                                                    </p>
                                                    <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                        Solicitamos inclusão do seu currículo em nosso novo sistema para que possa continuar
                                                        concorrendo as nossas oportunidades.
                                                    </p>
                                                    <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                        <center>
                                                        <a href="$linkSistema" target="_blank"> <img src="$imgAcessoSistema"> </a>
                                                        </center>
                                                    </p>
                                                </td>
                                                <td width="24"></td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                                <tr style="background-color: #FFF">
                                    <td>
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                    <td height="17">
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                    <td align="center">
                                        Tem alguma dúvida? Quer nos dar sugestões? <b>Entre em contato conosco</b> contato@alibras.com.br
                                    </td>
                                </tr>
                                <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                    <td height="10">
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <table cellpadding="0" cellspacing="0">
                                            <tr style="color: #FFF; font: normal 14px Arial, Tahoma, sans-serif; text-align: left;">
                                                <td style="padding-right: 30px; padding-top: 30px; padding-left: 30px;">
                                                    <img src="$logo_bottom" />
                                                </td>
                                                <td valign="bottom">
                                                    Você está recebendo esse email para recadastramento de seu currículo em nosso novo sistema.
                                                    <br /><br />
                                                </td>
                                            </tr>
                                        </table>
                                        <br /><br /><br /><br /><br />
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </body>
                    </html>
HTML;

        return $template;

    }

    /**
     * Envia email para os canditados para realizarem o cadastro do curriculo.
     * @param string $email Email do operador que tera sua senha enviada.
     * @return void
     * @author leonardocarvalho
     */
    public static function enviaSolicitacaoCadastro($email){

        try{

            $subject = self::SUBJECT_RECUPERAR_SENHA;
            $content = self::getTemplate();

            // Manda um email para operador solicitando o novo cadastro
            new Mail($email, $subject, $content);

        }
        catch(\Exception $e){
            throw new \Exception($e->getMessage(), $e->getCode());
        }

    }

    /**
     * Ler arquivo excel
     * @param string $xlsFilePath Caminho do arquivo excel
     * @return void
     * @author leonardocarvalho
     */
    public function readerXLS($xlsFilePath){
        $this->xlsPath = $xlsFilePath;
        $xls = \PHPExcel_IOFactory::createReaderForFile($xlsFilePath);
        /** @var $xlsReader \PHPExcel */
        $xlsReader = $xls->load($xlsFilePath);

        $this->xls = $xlsReader->getActiveSheet();
    }

    /**
     * Extrai os dados do arquivo xls
     * @return void
     * @author leonardocarvalho
     */
    public function extraiDadosTabela() {

        $indice = null;
        $vr = null;
        $valor = array();

        $highestColumnIndex = \PHPExcel_Cell::columnIndexFromString($this->xls->getHighestColumn());

        for($row = 2; $row <= $this->xls->getHighestRow(); $row++) {
            for($column = 0; $column < $highestColumnIndex; $column++) {
                if ($column == self::COLUNA_NM_CANDIDATO) { // Coluna com nome dos candidatos
                    $indice = strtoupper(trim($this->xls->getCellByColumnAndRow($column, $row)->getValue()));
                    $indice = iconv(mb_detect_encoding($indice), "ISO-8859-1", $indice);
                } elseif ($column == self::COLUNA_EMAIL_CANDIDATO) { // Coluna com email dos candidatos
                    $vr = trim($this->xls->getCellByColumnAndRow($column, $row)->getValue());
                }
                if ($indice) {
                    $valor[$indice] = $vr;
                }
            }
        }
        print_r($valor);
    }

}

//require 'C:/workfolder/fpa-teknisa/products/source/btl/public/bootstrap.php';

//require __DIR__.'../../../../../../../../setforms/setforms/lib/PHPExcel/PHPExcel.php';
//require 'C:/workfolder/fpa-teknisa/setforms/setforms/lib/PHPExcel/PHPExcel.php';

//$xlsPath = 'C:/Users/leonardocarvalho/Downloads/alibras_curriculos.xls';
//$xlsPath = 'C:/Users/leonardocarvalho/Downloads/ali_teste.xls';

//$xls = new SolicitaCadastro();
//$xls->readerXLS($xlsPath);
//$valores = $xls->extraiDadosTabela();
//file_put_contents('C:/Users/leonardocarvalho/Desktop/xls.log', print_r($valores, true));