<?php
namespace Planejamento\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Confirmarefe extends Base\Confirmarefe
{
    public static function insere(
        $cdfilial, $cdservfili, $nrcardapio, $dtcardapio, $cdcliente, $cddestfili,
        $cdturno, $qtcomeoriginal, $qtcomealterada, $qttotalalterada,
        $idqtdeaprovada, $dsparametros
    )
    {
        try {
            $nrorg = Ambiente::getNrorg();

            $maxconfirmarefe = Confirmarefe::getObjectByWhere(
                'NRORG = ?', array($nrorg), 'NRCONFIRMAREFE DESC'
            );
            if ($maxconfirmarefe instanceof Confirmarefe) {
                $maxconfirmarefe = $maxconfirmarefe->getNrconfirmarefe() + 1;
            } else {
                $maxconfirmarefe = 1;
            }

            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            $data = DateUtil::getDataAtual();
            $operador = Ambiente::getCdOperador();

            $confirmarefe = New Confirmarefe();

            $confirmarefe->setNrconfirmarefe($maxconfirmarefe);
            $confirmarefe->setCdfilial($cdfilial);
            $confirmarefe->setCdservfili($cdservfili);
            $confirmarefe->setNrcardapio($nrcardapio);
            $confirmarefe->setDtcardapio(
                DateUtil::getDataDeString(
                    $dtcardapio, 'd/m/Y', true
                )
            );
            $confirmarefe->setCdcliente($cdcliente);
            $confirmarefe->setCddestfili($cddestfili);
            $confirmarefe->setCdturno($cdturno);
            $confirmarefe->setQtcomeoriginal($qtcomeoriginal);
            $confirmarefe->setQtcomealterada($qtcomealterada);
            $confirmarefe->setQttotalalterada($qttotalalterada);
            $confirmarefe->setIdqtdeaprovada($idqtdeaprovada);
            $confirmarefe->setDsparametros($dsparametros);
            $confirmarefe->setNrorg($nrorg);
            $confirmarefe->setNrorginclusao($nrorg);
            $confirmarefe->setNrorgultatu($nrorg);
            $confirmarefe->setDtinclusao($data);
            $confirmarefe->setDtultatu($data);
            $confirmarefe->setCdoperinclusao($operador);
            $confirmarefe->setCdoperultatu($operador);
            $confirmarefe->persist();

            $connection->flush();
            $connection->commit();

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function aprovaCardapio(
        $cdfilial, $cdservfili, $nrcardapio, $dtcardapio
    )
    {
        try {
            $nrorg = Ambiente::getNrorg();

            $registros = Confirmarefe::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ? AND NRCARDAPIO = ?
                AND DTCARDAPIO = ? AND IDQTDEAPROVADA = ?',
                array(
                    $nrorg, $cdfilial, $cdservfili, $nrcardapio, $dtcardapio,
                    'PENDENTE'
                )
            );
            if ($registros) {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $data = DateUtil::getDataAtual();
                $operador = Ambiente::getCdOperador();

                foreach ($registros as $confirmarefe) {
                    $confirmarefe->setIdqtdeaprovada('APROVADA');
                    $confirmarefe->setNrorgultatu($nrorg);
                    $confirmarefe->setDtultatu($data);
                    $confirmarefe->setCdoperultatu($operador);
                    $confirmarefe->persist();
                }

                $connection->flush();
                $connection->commit();

                return true;
            }
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}