/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8550_SUPSTPO.sql

Descrio:
Atualiza a tabela de itens da apurao de preos

Criao:
09/01/2004 - Joo Fernando dos Reis Corra
*/

CREATE OR REPLACE
PROCEDURE ATUALIZA_ITMAPUR
  (P_CDCENTCMP   IN ITMAPURPREC.CDCENTITMAP%TYPE,
   P_NRSEQAPUR   IN ITMAPURPREC.NRSEQITMAP%TYPE,
   P_CDPRODUTO   IN ITMAPURPREC.CDPRODITMAP%TYPE,
   P_CDMARCA     IN ITMAPURPREC.CDMARCITMAP%TYPE,
   P_CDFORNECED  IN ITMAPURPREC.CDFORNITMAP%TYPE,
   P_CDREGIAO    IN ITMAPURPREC.CDREGITMAP%TYPE,
   P_NRCOLEPRECO IN ITMAPURPREC.NRCOLEITMAP%TYPE)
IS
   V_CDFILIAP    VARCHAR(4);
   V_CDFORNITMAP VARCHAR(21);
   V_CDPRODITMAP VARCHAR(10);

   V_IDEMITAFDES VARCHAR(1);
   V_CDEMPRESA   VARCHAR(2);
   V_CDEMITENTE  VARCHAR(4);
   V_IDPRODWEB   AUTOFORNE.IDAFPRODWEB%TYPE;
   V_IDAFOPERLOG AUTOFORNE.IDAFOPERLOG%TYPE;

BEGIN
   FOR C_ITMAPUR IN
     (SELECT
         ITMAPURPREC.CDFILIAP,
         ITMAPURPREC.CDFORNITMAP,
         ITMAPURPREC.CDPRODITMAP,
         PRODUTO.CDARVPROD
      FROM
         ITMAPURPREC,
         PRODUTO
      WHERE
         (ITMAPURPREC.CDCENTITMAP = P_CDCENTCMP)       AND
         (ITMAPURPREC.NRSEQITMAP  = P_NRSEQAPUR)       AND
         (ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO) AND
         (ITMAPURPREC.CDPRODITMAP = P_CDPRODUTO)       AND
         (ITMAPURPREC.CDMARCITMAP = P_CDMARCA)         AND
         (ITMAPURPREC.CDFORNITMAP = P_CDFORNECED)      AND
         (ITMAPURPREC.CDREGITMAP  = P_CDREGIAO)        AND
         (ITMAPURPREC.NRCOLEITMAP = P_NRCOLEPRECO)) LOOP

      V_CDEMITENTE := EMITENTE(C_ITMAPUR.CDFILIAP, C_ITMAPUR.CDPRODITMAP, C_ITMAPUR.CDFORNITMAP);
      V_IDPRODWEB  := 'N';
      SELECT
         NVL(MAX(PARAMPRODSUP.IDPRODWEB), 'N')
      INTO
         V_IDPRODWEB
      FROM
         PARAMPRODSUP
      WHERE
         (CDFILIAL   = C_ITMAPUR.CDFILIAP)    AND
         (CDPRODUTO  = C_ITMAPUR.CDPRODITMAP) AND
         (CDFORNECED = C_ITMAPUR.CDFORNITMAP);

      V_IDAFOPERLOG := 'X';
      SELECT
         NVL(MAX('2'),'X') INTO V_IDAFOPERLOG
      FROM
         PARAMPRODSUP
      WHERE
         (CDFILIAL  = C_ITMAPUR.CDFILIAP)    AND
         (CDPRODUTO = C_ITMAPUR.CDPRODITMAP) AND
         (CDFILIOPELOG IS NOT NULL);

      UPDATE ITMAPURPREC SET
        (ITMAPURPREC.IDTPFORPGTAP,
         ITMAPURPREC.CDTIPCOBAP,
         ITMAPURPREC.IDTIPOFRETAP,
         ITMAPURPREC.CDFORMPGTOAP,
         ITMAPURPREC.NRPARCPGTOAP,
         ITMAPURPREC.NRDIAPGFIAP,
         ITMAPURPREC.IDULTDIAPGTAF,
         ITMAPURPREC.DSPZOPGTCOAP,
         ITMAPURPREC.CONCKEYAP,
         ITMAPURPREC.CDSEGMARCCOL,
         ITMAPURPREC.VRPERDESIAP,
         ITMAPURPREC.VRPRECUNIAP) =
        (SELECT
            ITEMCOLE.IDTPFOPGTCOL,
            ITEMCOLE.CDTIPCOB,
            ITEMCOLE.IDTIPFREITM,
            ITEMCOLE.CDFORMPGTO,
            ITEMCOLE.NRPARCPGTCOL,
            ITEMCOLE.NRDIAPGFXCOL,
            ITEMCOLE.IDUTDIAPGCOL,
            ITEMCOLE.DSPZOPGTCONC,
            (C_ITMAPUR.CDFILIAP ||
             ITEMCOLE.CDFORNECED ||
             SUBSTR(V_CDEMITENTE, 3, 2) ||
             ITEMCOLE.IDTPFOPGTCOL ||
             ITEMCOLE.CDTIPCOB ||
             ITEMCOLE.IDTIPFREITM  ||
             ITEMCOLE.CDFORMPGTO ||
             ITEMCOLE.NRPARCPGTCOL ||
             ITEMCOLE.NRDIAPGFXCOL ||
             ITEMCOLE.IDUTDIAPGCOL ||
             SUBSTR(V_CDEMITENTE, 1, 1) ||
             V_IDPRODWEB ||
             V_IDAFOPERLOG),
            ITEMCOLE.CDSEGMARCCOL,
            ITEMCOLE.VRPERDESITM,
            ITEMCOLE.VRPRECUNIITM
         FROM
            ITEMCOLE
         WHERE
            (ITEMCOLE.CDFILIAL    = P_CDCENTCMP)  AND
            (ITEMCOLE.CDPRODUTO   = P_CDPRODUTO)  AND
            (ITEMCOLE.CDMARCA     = P_CDMARCA)    AND
            (ITEMCOLE.CDFORNECED  = P_CDFORNECED) AND
            (ITEMCOLE.CDREGIAO    = P_CDREGIAO)   AND
            (ITEMCOLE.NRCOLEPRECO = P_NRCOLEPRECO))
      WHERE
         (ITMAPURPREC.CDCENTITMAP = P_CDCENTCMP)  AND
         (ITMAPURPREC.NRSEQITMAP  = P_NRSEQAPUR)  AND
         (ITMAPURPREC.CDPRODITMAP = P_CDPRODUTO)  AND
         (ITMAPURPREC.CDMARCITMAP = P_CDMARCA)    AND
         (ITMAPURPREC.CDFORNITMAP = P_CDFORNECED) AND
         (ITMAPURPREC.CDREGITMAP  = P_CDREGIAO)   AND
         (ITMAPURPREC.NRCOLEITMAP = P_NRCOLEPRECO);
   END LOOP;
END;
/

